#include "nrf24l01.h"
u8 Received_Data[Max_Data_Len];

u8 RF_Init(SPI_TypeDef* SPIx, RF_InitTypeDef* RF_InitStruct)		   //if fast<>0 using short programming only for change RF_Mode RX/TX
{	
   u8 temp=RF_InitStruct->RF_Config|RF_InitStruct->RF_Power_State|RF_InitStruct->RF_CRC_Mode|RF_InitStruct->RF_Mode;
   if (RF_Read_Cmd(SPIx, CONFIG_REG)!=temp)
   {
   temp=RF_Send_Cmd(SPIx, CONFIG_REG, temp);															
		RF_Send_Cmd(SPIx, EN_AA_REG,RF_InitStruct->RF_Pipe_Auto_Ack);										//EN_AA 		REG
		RF_Send_Cmd(SPIx, EN_RXADDR_REG,RF_InitStruct->RF_Enable_Pipe);									//EX_RXADDR		REG
		RF_Send_Cmd(SPIx, SETUP_AW_REG,RF_InitStruct->RF_Setup);											//SETUP_AW		REG
		RF_Send_Cmd(SPIx, SETUP_RETR_REG,(RF_InitStruct->RF_Auto_Retransmit_Count&0x0F)|(((RF_InitStruct->RF_Auto_Retransmit_Delay)&0x0F)<<4));
		RF_Send_Cmd(SPIx, RF_CH_REG,(RF_InitStruct->RF_Channel&0x7F));									//RF Chanel		REG
		RF_Send_Cmd(SPIx, RF_SETUP_REG,(0x01|RF_InitStruct->RF_TX_Power|RF_InitStruct->RF_Data_Rate));	//RF_SETUP		REG
		RF_Send_Adrs(SPIx, RX_ADDR_P0_REG,RF_InitStruct->RF_RX_Adress_Pipe0);								//RX adress for PIPE0
		RF_Send_Adrs(SPIx, RX_ADDR_P1_REG,RF_InitStruct->RF_RX_Adress_Pipe1);								//RX adress for PIPE1
		RF_Send_Cmd(SPIx, RX_ADDR_P2_REG,RF_InitStruct->RF_RX_Adress_Pipe2);								//RX adress for PIPE2 (only LSB) 
		RF_Send_Cmd(SPIx, RX_ADDR_P3_REG,RF_InitStruct->RF_RX_Adress_Pipe3);								//RX adress for PIPE3 (only LSB)
		RF_Send_Cmd(SPIx, RX_ADDR_P4_REG,RF_InitStruct->RF_RX_Adress_Pipe4);								//RX adress for PIPE4 (only LSB)
		RF_Send_Cmd(SPIx, RX_ADDR_P5_REG,RF_InitStruct->RF_RX_Adress_Pipe5);								//RX adress for PIPE5 (only LSB)
		RF_Send_Adrs(SPIx, TX_ADDR_REG,RF_InitStruct->RF_TX_Adress);
		RF_Send_Cmd(SPIx, RX_PW_P0_REG,RF_InitStruct->RF_Payload_Size_Pipe0);
		RF_Send_Cmd(SPIx, RX_PW_P1_REG,RF_InitStruct->RF_Payload_Size_Pipe1);
		RF_Send_Cmd(SPIx, RX_PW_P2_REG,RF_InitStruct->RF_Payload_Size_Pipe2);
		RF_Send_Cmd(SPIx, RX_PW_P3_REG,RF_InitStruct->RF_Payload_Size_Pipe3);
		RF_Send_Cmd(SPIx, RX_PW_P4_REG,RF_InitStruct->RF_Payload_Size_Pipe4);
		RF_Send_Cmd(SPIx, RX_PW_P5_REG,RF_InitStruct->RF_Payload_Size_Pipe5);
		PIN_ON(CE);
	}
	else temp=0;
	return temp;			 
}

u8 RF_Send_Cmd(SPI_TypeDef* SPIx, u8 adrs, u8 cmd)							//write data to register procedure
{	u8 temp;
	PIN_OFF(CE);
	PIN_OFF(CSN);
	temp=SPI_ReadByte(SPIx,(0x1F&adrs)|(1<<5));
	SPI_SendByte(SPIx,cmd);
	PIN_ON(CSN);
	return temp;
}
u8 RF_Read_Cmd(SPI_TypeDef* SPIx, u8 adrs)										//read data from register
{	u8 temp;	
	PIN_OFF(CE);
	PIN_OFF(CSN);
	SPI_SendByte(SPIx,0x1F&adrs);
	temp=SPI_ReadByte(SPIx,0xFF);
	PIN_ON(CSN);
	PIN_ON(CE);
	return temp;
}

void RF_Send_Adrs(SPI_TypeDef* SPIx, u8 adrs, u8 cmd[Max_Adress_Len])
{	u8 temp;
	PIN_OFF(CSN);
	SPI_SendByte(SPIx,adrs|(1<<5));
	for (temp=0;temp!=Max_Adress_Len;temp++) SPI_SendByte(SPIx,cmd[temp]);	
	PIN_ON(CSN);
}

u8 RF_Send_Data(SPI_TypeDef* SPIx, u8 Data[Max_Data_Len],u8 Dala_Len)			//returns 1 if data send succesfuly, Data_Len = num of bytes to send
{	u8 temp;
	u16 cnt=0;
	temp=PIN_IN(IRQ);
	if(temp==0) RF_IRQ_CLEAR(SPIx,0xFF);
	temp=PIN_IN(IRQ);
	PIN_OFF(CE);
	PIN_OFF(CSN);
	temp=SPI_ReadByte(SPIx,0xA0);				  						//W_TX_PAYLOAD Command
	for (cnt=0;cnt!=Dala_Len;cnt++)  SPI_SendByte(SPIx,Data[cnt]);
	PIN_ON(CSN);
	PIN_ON(CE);
	cnt=0;
	while ((cnt!=Payload_send_delay)&(PIN_IN(IRQ))!=0)	{cnt++;}
	temp=PIN_IN(IRQ);
	if (temp!=0) cnt = 0;
			else cnt = 1;
	PIN_OFF(CE);
	RF_IRQ_CLEAR(SPIx, RF_TX_DS_IRQ_CLEAR);
	return cnt;
}   

u8 RF_Receive_Data(SPI_TypeDef* SPIx, u8 Dala_Len)					  			//returns 0xFF if no data received. Data_Len = num of bytes to receive
{	u8 temp;													  	//returns PIPE num if data received succesfully
	u8 cnt=0;												//all received data fills Received_Data[Dala_Len] array
	temp=PIN_IN(IRQ);
	if (temp!=0)	return 0xFF;	
	else
	{	
		PIN_OFF(CE);
		PIN_OFF(CSN);
		temp = SPI_ReadByte(SPI1,0x61);					//read status reg and send R_RX_PAYLOAD Command	
		temp=(temp&0x0E);															  	
		for (cnt=0;cnt!=Dala_Len;cnt++)	Received_Data[cnt]=SPI_ReadByte(SPI1,0xFF);
		PIN_ON(CSN);
		PIN_ON(CE);
		RF_IRQ_CLEAR(SPIx, RF_RX_DR_IRQ_CLEAR);
		return temp;
	}			
}

u8 RF_Carrier_Detect(SPI_TypeDef* SPIx)										//returns 1 if Carrier Detected on current channel
	{return (RF_Read_Cmd(SPIx, CD_REG)&0x01);}

u8 RF_Count_Lost_Packets(SPI_TypeDef* SPIx)									//returns num of Lost Packatets 
	{return (((RF_Read_Cmd(SPIx, OBSERV_TX_REG))&0xF0)>>4);}

u8 RF_Count_Resend_Packets(SPI_TypeDef* SPIx)								//returns nut of Resend Packets
	{return ((RF_Read_Cmd(SPIx, OBSERV_TX_REG))&0x0F);}

void RF_IRQ_CLEAR (SPI_TypeDef* SPIx, u8 CMD)											//Clears IRQ
	{RF_Send_Cmd(SPIx, STATUS_REG, CMD);PIN_ON(CE);} 

u8 RF_Single_Package_Send(SPI_TypeDef* SPIx, u8 Data[Max_Data_Len],u8 Dala_Len)	//enters TX mode, sends a package and returns to RX mode
{																//returns 1 if data send succesfuly, Data_Len = num of bytes to send
    u8 tmp1;
    u8 tmp2=RF_Read_Cmd(SPIx, CONFIG_REG);
	RF_Send_Cmd(SPIx, CONFIG_REG,(tmp2&0xFE));  						//set TX mode
	tmp1=RF_Send_Data(SPIx, Data,Dala_Len);							//send data
	RF_Send_Cmd(SPIx, CONFIG_REG,(tmp2|0x01));						//SET RX mode
	PIN_ON(CE);										//ON AIR mode
	return tmp1;
}

void RF_Pin_Test(void)
{
	while(1)
	{
		PIN_INV(CSN);
		PIN_INV(CE);
		delay_ms(1000);
	}
}
